/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.4.21018 at Thu Jun 02 03:26:29 AM MEST 2011
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*************************************************************************
 * TCI Codec binary string routines
 *
 *************************************************************************/

#ifndef __BINARY_STRING_H__
#define __BINARY_STRING_H__

/* Envelop to reduce number of reallocs */
typedef struct _MyBinaryString {
  BinaryString string;
  unsigned long allocated;
} MyBinaryString;

/* Iterator to process binary string */
typedef struct _BinaryStringIter {
  BinaryString string;
  unsigned long bit_index;
} BinaryStringIter;

/* Several functions to append byte, 2 bytes, 4 bytes and n bytes to the end of binary string  */

void binary_string_append_char (MyBinaryString *string, unsigned char data);
void binary_string_append_short (MyBinaryString *string, unsigned short data);
void t3rt_binary_string_append_long (MyBinaryString *string, unsigned long data);
void binary_string_append_bytes (MyBinaryString *string, const unsigned char *data, unsigned long bytesize);

/* Several functions to extract byte, 2 bytes, 4 bytes and n bytes from binary string 
 * Itertor is moved forward after extraction
 */

unsigned char binary_string_get_char (BinaryStringIter *iter);
unsigned short binary_string_get_short (BinaryStringIter *iter);
unsigned long binary_string_get_long (BinaryStringIter *iter);
void binary_string_get_bytes (BinaryStringIter *iter, unsigned long n, unsigned char *data);


#endif
