/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.4.21018 at Thu Jun 02 03:26:28 AM MEST 2011
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_custom.h
 *
 * Description:
 *      This file declares custom IBM Rational functions that
 *      are not part of TCI standard
 */
 
#ifndef __tci_custom_h
#define __tci_custom_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"

#ifdef TCI_LOCAL_MODE

/* 
 * int tciInit(int argc, char *argv[])
 *
 * General initialization function for TCI interface
 * Should be called outside any RTS function
 * No TCI functions should be called pror to tciInit()
*/

int tciInit(int argc, char *argv[]);

/*
 * void tciFinalize()
 *
 * General finalization function for TCI interface
 * No TCI functions should be called after tciFinalize()
*/


void tciFinalize();

/*
 * void *tciMemoryAllocate(unsigned long bytes)
 *
 * This function allocates memory block in temporary memory area
 * It's just a wrapper to t3rt_memory_temp_allocate() function
 * 
*/

void *tciMemoryAllocate(unsigned long bytes);


/* 
 * int tciStartTestsuiteServer(int argc, char *argv[])
 *
 * Main function for Tester GUI controled testsuite execution
 *
 * main() function in ETS should like like:
 *  int main(int argc, char *argv[]) {
 *    return tciStartTestsuiteServer(argc, argv);
 *  }
 *
 * Initialization of TCI interface is done inside tciStartTestsuiteServer() function
 *
*/

int tciStartTestsuiteServer(int argc, char *argv[]);

#endif


#ifdef __cplusplus
}
#endif

#endif
