/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.4.21018 at Thu Jun 02 03:26:28 AM MEST 2011
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_misc.h
 *
 * Description:
 *      This file declares misceleneous C mapping specific
 *      TCI data structures 
 */
 
#ifndef __tci_misc_h
#define __tci_misc_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"

typedef IDL_ATTRIB(string) char* String;

                 /* VERDICT representation */
 
/* 
 * Since the TciVerdictValue interface is defined in terms of integers, 
 * consensus must be established on which value defines which verdict. 
*/

typedef unsigned long int TciVerdictValue;

extern const long int TCI_VERDICT_NONE;
extern const long int TCI_VERDICT_PASS;
extern const long int TCI_VERDICT_INCONC;
extern const long int TCI_VERDICT_FAIL;
extern const long int TCI_VERDICT_ERROR;

#define TCI_VERDICT_NONE_STATIC    0 /* NONE */	
#define TCI_VERDICT_PASS_STATIC    1 /* PASS */		
#define TCI_VERDICT_INCONC_STATIC  2 /* INCONC */		
#define TCI_VERDICT_FAIL_STATIC    3 /* FAIL */		
#define TCI_VERDICT_ERROR_STATIC   4 /* ERROR */		

                 /* OBJID representation */

/*
 * Since the Objid value is returned "as is" via the Objid value interface, 
 * a representation must be defined.
*/

typedef struct _TciObjidElemValue
  {  
	String elem_as_ascii;  
    long int elem_as_number;  
    P_VOID aux;
  } TciObjidElemValue;	

typedef struct _TciObjidValue
  {  
    long int length;  
	IDL_ATTRIB(size_is(length))
    TciObjidElemValue *elements;
  } *TciObjidValue;	

                  /* CHARSTRING representation */
 
typedef struct _TciCharStringValue
  {  
    unsigned long int length;
	IDL_ATTRIB(size_is(length))
    char* string;
  } *TciCharStringValue;

                  /* UNIVERSAL CHARSTRING representation */
#define TCI_UC_BASE_TYPE unsigned char
#define TCI_UC_LENGTH 4

typedef TCI_UC_BASE_TYPE TciUCValue[TCI_UC_LENGTH]; 
typedef IDL_ATTRIB(size_is(TCI_UC_LENGTH)) TCI_UC_BASE_TYPE* TciUCReturnValue;

typedef struct _TciUCStringValue
  {  
    unsigned long int length;  
	IDL_ATTRIB(size_is(length))
    TciUCValue *string;
  } *TciUCStringValue;	


#ifdef __cplusplus
}
#endif
  
#endif
